<?php

/*********************************************
*	Froogle Static for Interspire Shopping Cart
*
*	$Author: martin $
*	$Date: 2009-07-01 12:45:55 +0100 (Wed, 01 Jul 2009) $
*	$Revision: 34 $
*
*
*********************************************/


	class ISC_FROOGLE
	{
		var $localpath;
		var $ignore_duplicates;
				
		public function HandlePage()
		{
			$this->localpath = realpath(dirname(__FILE__)."/../../");
			$this->ExportFroogle();
		}


		private function ExportFroogle()
		{
			/* ==== Configurable variables ==== */
			
			// Export filename 
			$exportFile = "froogle-export.xml";
			
			// Export duplicate products (true/false)
			$this->ignore_duplicates = false;
			
			// Show your inventory stock for products (if available)
			$this->show_quantity = true;
			
			/* ==== END Configurable variables ==== */
			
			
			// Remove our existing file before we start
			@unlink($this->localpath."/cache/".$exportFile);
			
		
			$fp = fopen($this->localpath."/cache/".$exportFile, "w+");
			if(!$fp) {
				exit;
			}

			$exportDate = isc_date("Y-m-d\TH:i:s\Z", time());

			$header = '<?xml version="1.0" encoding="' . GetConfig('CharacterSet') . '"?>
<feed xmlns="http://www.w3.org/2005/Atom" xmlns:g="http://base.google.com/ns/1.0">
	<title>'.isc_html_escape($GLOBALS['StoreName']).'</title>
	<link rel="self" href="'.str_replace("https://", "http://",$GLOBALS['ShopPath']).'"/>
	<updated>'.$exportDate.'</updated>
	<author>
		<name>' . isc_html_escape($GLOBALS['StoreName']) . '</name>
	</author>
	<id>tag:'.time().'</id>
	';

			// Add the header to the file
			fwrite($fp, $header);
			$start = 0;

			// Count the number of products we'll be exporting
			$query = "
				SELECT COUNT(*)
				FROM [|PREFIX|]products p
				LEFT JOIN [|PREFIX|]categoryassociations ca ON (p.productid=ca.productid)
				WHERE prodvisible=1
			";
			$result = $GLOBALS['ISC_CLASS_DB']->Query($query);
			$numProducts = $GLOBALS['ISC_CLASS_DB']->FetchOne($result);

			ob_end_clean();

			$entryBuffer = array();
			$expirationDate = isc_date("Y-m-d", time()+60*60*24*30);

			$query = "
				SELECT p.*, c.catname,
					(SELECT b.brandname FROM [|PREFIX|]brands b WHERE b.brandid=p.prodbrandid) AS brandname,
					(SELECT pi.imagefile FROM [|PREFIX|]product_images pi WHERE pi.imageprodid=p.productid AND pi.imageisthumb=0 AND pi.imagesort=1) AS imagefile
				 FROM [|PREFIX|]products p
				INNER JOIN [|PREFIX|]categoryassociations ca ON (p.productid=ca.productid)
				INNER JOIN [|PREFIX|]categories c ON (ca.categoryid=c.categoryid)
				WHERE p.prodvisible=1
			";
			$done = $start;
			
			$result = $GLOBALS['ISC_CLASS_DB']->Query($query);
			
			$exported = array();	// Track exported products to avoid duplication
			
			while($row = $GLOBALS['ISC_CLASS_DB']->Fetch($result)) {
				
				// Check if duplicates to be allowed or filtered out.
				if(@$exported[$row['productid']] && @$this->ignore_duplicates) {
					// Ignore duplicates
					continue;
				}
				$exported[$row['productid']] = true;	// Product output flag
				
				$link = ProdLink($row['prodname']);
				$link = str_replace("https://", "http://", $link);
				$desc = strip_tags($row['proddesc']);
				// attempt to strip out control characters
				$new_desc = @preg_replace("/\p{C}/u", " ", $desc);
				if ($new_desc != "") {
					$desc = $new_desc;
				}

				// If the product is on sale, use the sale price instead of the product price
				if (($row['prodsaleprice'] < $row['prodprice']) && ($row['prodsaleprice'] > 0)) {
					$price = CNumeric($row['prodsaleprice']);
				}
				else {
					$price = CNumeric($row['prodprice']);
				}
				$entry = array();
				if($row['brandname']) {
					$entry[] = sprintf("<g:brand><![CDATA[%s]]></g:brand>", isc_html_escape($row['brandname']));
				}

				$entry []= sprintf("<g:department><![CDATA[%s]]></g:department>", isc_html_escape($row['catname']));
				if(isc_strlen($desc) > 1000) {
					$desc = isc_substr($desc, 0, 997)."...";
				}
				//$entry[] = sprintf("<summary><![CDATA[%s]]></summary>", isc_html_escape($desc));
				// Summary appears to have been deprecated in favour of the newer Description tag
				$entry[] = sprintf("<description><![CDATA[%s]]></description>", isc_html_escape($desc));
				$entry[] = sprintf("<g:expiration_date><![CDATA[%s]]></g:expiration_date>", $expirationDate);
				$entry[] = sprintf("<g:id>%d</g:id>", $row['productid']);

				if($row['imagefile']) {
					$image = str_replace("https://", "http://",$GLOBALS['ShopPath']).'/'.GetConfig('ImageDirectory').'/'.$row['imagefile'];
					$entry[] = sprintf("<g:image_link>%s</g:image_link>", isc_html_escape($image));
				}

				$entry[] = sprintf("<link>%s</link>", isc_html_escape($link));
				$entry[] = sprintf("<g:price>%s</g:price>", $price);
				
				// Addition of quantity variable (depends on $show_quantity variable
				if(@$this->show_quantity && intval($row['prodcurrentinv']) > 0) {
					$entry[] = sprintf("<g:quantity>%s</g:quantity>", intval($row['prodcurrentinv']));
				}
				
				// Addition of weight variable if available
				if($row['prodweight'] > 0) {
					$entry[] = sprintf("<g:weight>%s</g:weight>", floatval($row['prodweight']));
				}
				// Condition tag/attribute required so we'll assume "new"
				$condition = @isset($row['prodcondition']) ? isc_html_escape(isc_strtolower($row['prodcondition'])) : 'new';
				$entry[] = sprintf("<g:condition><![CDATA[%s]]></g:condition>", $condition);
				
				if($row['prodcode']) {
					$entry[] = sprintf("<g:model_number><![CDATA[%s]]></g:model_number>", isc_html_escape($row['prodcode']));
				}
				$entry = implode("\n\t", $entry);
				$entry = sprintf("<entry>
<title><![CDATA[%s]]></title>
	%s
</entry>\n",
					isc_html_escape($row['prodname']),
					$entry);

				fwrite($fp, $entry);
				++$done;
			}

			fwrite($fp, "</feed>");
			fclose($fp);
			exit;
		}

	}

?>
